import sys
import random

def noFunc(): pass

try:
	import pygame
	from pygame.locals import *
except ImportError:
	print "Requires PyGame"
	sys.exit(1)	
try:
	from OpenGL.GL import *
	from OpenGL.GLU import *
	
except ImportError:
	print "Requires PyOpenGL"
	sys.exit(1)
try:
	from numpy import *
except ImportError:
	print "Requires numpy"
	sys.exit(1)
	
from math import *
from data import filepath

root2 = sqrt(2)

def drawWorld(currentPositions, pos):
	try:
		import psyco
		psyco.full()
	except:
		print "No psyco"
	
	for i in range(20):	
		glColor4f(1 - (i / 20.0), (i / 20.0), 0.0, 1 - (i / 20.0))
		glPushMatrix()
		glBegin(GL_LINE_STRIP)
		for j in range(20):
			rads = j * 9 * pi / 90 
			radsPlus = (j + 1) * 9 * pi / 90 
			glVertex3f(cos(rads) + currentPositions[i + 1][0], sin(rads) + currentPositions[i + 1][1], currentPositions[i + 1][2])
			glVertex3f(cos(radsPlus) + currentPositions[i + 1][0], sin(radsPlus) + currentPositions[i + 1][1], currentPositions[i + 1][2])
			glVertex3f(cos(radsPlus) + currentPositions[i][0], sin(radsPlus) + currentPositions[i][1], currentPositions[i][2])
			glVertex3f(cos(rads) + currentPositions[i][0], sin(rads) + currentPositions[i][1], currentPositions[i][2])	
		
		glEnd()
		glPopMatrix()
		
	glColor4f(0.0, 0.0, 1.0, 0.5)
	glBegin(GL_QUADS)
	glVertex3f(-0.005 + pos[0], -0.05 + pos[1], pos[2])
	glVertex3f(-0.005 + pos[0], 0.05 + pos[1], pos[2])
	glVertex3f(0.005 + pos[0], 0.05 + pos[1], pos[2])
	glVertex3f(0.005 + pos[0], -0.05 + pos[1], pos[2])	
	glVertex3f(-0.05 + pos[0], -0.005 + pos[1], pos[2])
	glVertex3f(-0.05 + pos[0], 0.005 + pos[1], pos[2])
	glVertex3f(0.05 + pos[0], 0.005 + pos[1], pos[2])
	glVertex3f(0.05 + pos[0], -0.005 + pos[1], pos[2])	
	glEnd()			
	
def getNextPos(currentPos, lastChange, iTick):
	change = lastChange[0] / 3.0 + 0.1 * ((random.random() - 0.5) * ((iTick / 400) + 10) / 5.0), lastChange[1] / 3.0 + 0.1 * ((random.random() - 0.5) * ((iTick / 400) + 10) / 5.0)
	return change, currentPos + array((change[0], change[1], -1), "f")
		
def main():
	pygame.init()
	setupScreen()
	initOGL()	
	
	glClear(GL_COLOR_BUFFER_BIT)
	glClear(GL_DEPTH_BUFFER_BIT)
	glColor4f(1.0, 1.0, 1.0, 1.0)
	font = pygame.font.Font(filepath("FuturexVoyager.ttf"), 72)
	smallFont = pygame.font.Font(filepath("FuturexVoyager.ttf"), 52)
	titleSurf = font.render("Twisty Tunnels", True, (255, 255, 255)).convert_alpha()
	
	titleTexture = glGenTextures(1)
	timeTexture = glGenTextures(1)
	btimeTexture = glGenTextures(1)
	
	glEnable(GL_TEXTURE_2D)
	glBindTexture(GL_TEXTURE_2D, titleTexture)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
	
	scaleTex = scaleToPOT(titleSurf)
	
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, scaleTex.get_width(), scaleTex.get_height(), 0, GL_RGBA, GL_UNSIGNED_BYTE, pygame.image.tostring(scaleTex, "RGBX", 1))

	glMatrixMode(GL_PROJECTION)
	glPushMatrix()
	glLoadIdentity()
	gluOrtho2D(0, 800, 0, 600)
	
	glBegin(GL_QUADS)
	glTexCoord2f(0, 0)
	glVertex2f(400 - titleSurf.get_width() / 2, 300 - titleSurf.get_height() / 2)
	glTexCoord2f(0, 1)
	glVertex2f(400 - titleSurf.get_width() / 2, 300 + titleSurf.get_height() / 2)
	glTexCoord2f(1, 1)
	glVertex2f(400 + titleSurf.get_width() / 2, 300 + titleSurf.get_height() / 2)
	glTexCoord2f(1, 0)
	glVertex2f(400 + titleSurf.get_width() / 2, 300 - titleSurf.get_height() / 2)		
	glEnd()	
	
	glPopMatrix()
	glMatrixMode(GL_MODELVIEW)
	
	glDisable(GL_TEXTURE_2D)
		
	pygame.display.flip()
	
	bestTime = 0
	
	bTitle = True
	while bTitle:
		for event in pygame.event.get():
			if event.type == QUIT:
				sys.exit(0)
			if event.type == KEYDOWN:
				bTitle = False
			if event.type == MOUSEBUTTONUP:
				bTitle = False
	
	while 1:
		lastChange = (0, 0)
		
		positions = [array((0, 0, 0), "f"), array((0, 0, 0), "f")]
		for i in range(80):
			nextPos = getNextPos(positions[-1], lastChange, 0)
			lastChange = nextPos[0]
			positions.append(nextPos[1])
		
		clock = pygame.time.Clock()
		clock.tick()
		
		pos = 0
		posAccum = 0
		
		xPos = 0
		yPos = 0
		
		iTick = 2000 
		
		oldX = 0
		oldY = 0
		
		time = 0
		
		level = iTick / 400
		
		print "LEVEL 1"
		
		while 1:
			iTick += 1
			
			if iTick / 400 != level:
				level = iTick / 400
				print "LEVEL", level - 4
			
			for event in pygame.event.get():
				if event.type == QUIT:
					sys.exit(0)
					
			keystates = pygame.key.get_pressed()

			if keystates[K_LEFT]:
				xPos -= 0.01
				oldX -= 0.01
				glTranslatef(0.01, 0.0, 0.0)
			elif keystates[K_RIGHT]:
				xPos += 0.01
				oldX += 0.01
				glTranslatef(-0.01, 0.0, 0.0)
			elif keystates[K_UP]:
				yPos += 0.01
				oldY += 0.01
				glTranslatef(0.0, -0.01, 0.0)
			elif keystates[K_DOWN]:
				yPos -= 0.01
				oldY -= 0.01
				glTranslatef(0.0, 0.01, 0.0)
				
			oldX *= 0.9
			oldY *= 0.9
			
			xPos += oldX
			yPos += oldY
			
			glTranslatef(-oldX, -oldY, 0.0)
				
			pos += 0.01 * ((iTick / 400) + 10)
			posAccum += 0.01 * ((iTick / 400) + 10)
			glTranslatef(0.0, 0.0, 0.01 * ((iTick / 400) + 10))
						
			if posAccum >= 1:
				posAccum -= 1
				positions.pop(0)
				nextPos = getNextPos(positions[-1], lastChange, iTick)
				lastChange = nextPos[0]
				positions.append(nextPos[1])

					
			zClose = fmod(pos, 1)
			
			tpos = positions[int(floor(posAccum)) + 1] * (1 - zClose) + positions[int(ceil(posAccum)) + 1] * zClose
					
			if (xPos - tpos[0]) ** 2 + (yPos - tpos[1]) ** 2 > 1:
				break
				
				
			glClear(GL_COLOR_BUFFER_BIT)
			glClear(GL_DEPTH_BUFFER_BIT)
			
			arPos = (xPos, yPos, -pos - 1)		
					
			drawWorld(positions, arPos)
					
			pygame.display.flip()
					
			#print 1000.0 / clock.tick(30)
			time += 1.0 / clock.tick(30)
			
		bNewB = False
			
		if time > bestTime:
			bestTime = time
			bNewB = True
			
		glLoadIdentity()
			
		glColor4f(1.0, 1.0, 1.0, 1.0)
		glClear(GL_DEPTH_BUFFER_BIT)
			
		bTime = True	
			
		timeS = str(time)
		timeStr = timeS[0] + timeS[1] + timeS[2] + timeS[3] + timeS[4]
			
		timeSurf = smallFont.render("TIME: " + timeStr + "s", True, (255, 255, 255)).convert_alpha()
		
		btimeS = str(bestTime)
		btimeStr = btimeS[0] + btimeS[1] + btimeS[2] + btimeS[3] + btimeS[4]		
		
		if bNewB:
			bestTimeSurf = smallFont.render("NEW BEST TIME: " + btimeStr + "s", True, (255, 255, 255)).convert_alpha()
		else:
			bestTimeSurf = smallFont.render("BEST TIME: " + btimeStr + "s", True, (255, 255, 255)).convert_alpha()
		
		glEnable(GL_TEXTURE_2D)
		glBindTexture(GL_TEXTURE_2D, timeTexture)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
	
		scaleTex = scaleToPOT(timeSurf)
		
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, scaleTex.get_width(), scaleTex.get_height(), 0, GL_RGBA, GL_UNSIGNED_BYTE, pygame.image.tostring(scaleTex, "RGBX", 1))

		glMatrixMode(GL_PROJECTION)
		glPushMatrix()
		glLoadIdentity()
		gluOrtho2D(0, 800, 0, 600)
		
		glBegin(GL_QUADS)
		glTexCoord2f(0, 0)
		glVertex2f(400 - timeSurf.get_width() / 2, 350 - timeSurf.get_height() / 2)
		glTexCoord2f(0, 1)
		glVertex2f(400 - timeSurf.get_width() / 2, 350 + timeSurf.get_height() / 2)
		glTexCoord2f(1, 1)
		glVertex2f(400 + timeSurf.get_width() / 2, 350 + timeSurf.get_height() / 2)
		glTexCoord2f(1, 0)
		glVertex2f(400 + timeSurf.get_width() / 2, 350 - timeSurf.get_height() / 2)		
		glEnd()	
		
		glBindTexture(GL_TEXTURE_2D, btimeTexture)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
	
		scaleTex = scaleToPOT(bestTimeSurf)
		
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, scaleTex.get_width(), scaleTex.get_height(), 0, GL_RGBA, GL_UNSIGNED_BYTE, pygame.image.tostring(scaleTex, "RGBX", 1))
		
		glBegin(GL_QUADS)
		glTexCoord2f(0, 0)
		glVertex2f(400 - bestTimeSurf.get_width() / 2, 250 - bestTimeSurf.get_height() / 2)
		glTexCoord2f(0, 1)
		glVertex2f(400 - bestTimeSurf.get_width() / 2, 250 + bestTimeSurf.get_height() / 2)
		glTexCoord2f(1, 1)
		glVertex2f(400 + bestTimeSurf.get_width() / 2, 250 + bestTimeSurf.get_height() / 2)
		glTexCoord2f(1, 0)
		glVertex2f(400 + bestTimeSurf.get_width() / 2, 250 - bestTimeSurf.get_height() / 2)		
		glEnd()			
		
		glPopMatrix()
		glMatrixMode(GL_MODELVIEW)
		
		glDisable(GL_TEXTURE_2D)
		
		pygame.display.flip()
			
		while bTime:
			for event in pygame.event.get():
				if event.type == QUIT:
					sys.exit(0)
				if event.type == KEYDOWN:
					bTime = False
				if event.type == MOUSEBUTTONUP:
					bTime = False				
			
			
		print "TIME: " + str(time) + " seconds"
			
	
def setupScreen():
	pygame.display.set_mode((800, 600), OPENGL | DOUBLEBUF)

def initOGL():
	glClearColor(0, 0, 0, 1)
	glClear(GL_COLOR_BUFFER_BIT)
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glShadeModel(GL_SMOOTH)
	
	glEnable(GL_LINE_SMOOTH)
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST)
	
	glEnable(GL_POINT_SMOOTH)
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST)	
	
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1)
	
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	gluOrtho2D(-1, 1, -1, 1)
	gluPerspective(45, 4 / 3.0, 0.1, 50)
		
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	
	glColor4f(1.0, 0.0, 0.0, 1.0)
	glDisable(GL_TEXTURE_2D)
	
	
def scaleToPOT(texture):
	x = 1
	y = 1
	
	while x < texture.get_width():
		x *= 2
	while y < texture.get_height():
		y *= 2	
	
	texture = pygame.transform.rotozoom(texture, 0, min(float(x) / texture.get_width(), float(y) / texture.get_height()))
		
	return pygame.transform.scale(texture, (x, y))	
